<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <script src="https://cdn.jsdelivr.net/npm/vue@2.6.14/dist/vue.js"></script>
    <script src="https://unpkg.com/vuex@3.6.2/dist/vuex.js"></script>
    <title>Document</title>
  </head>
  <body>
    <div id="app">
      <h3>{{titulo}}</h3>
      <padre></padre>
    </div>
    <script>
      Vue.component("padre", {
        template: `
          <div class="padre">
            <h4>Componente Padre</h4>
            <p>Contador: {{count}}</p>
            <hijo></hijo>
            <br>
            <button v-on:click="obtenerPublicaciones">Obtener publicaciones</button>
            <ul class="lista" v-for="pub in publicaciones">
              <li>{{pub.name}}</li>
            </ul>
          </div>
        `,
        computed: {
          ...Vuex.mapState(["count", "publicaciones"]),
        },
        methods: {
          ...Vuex.mapActions(["obtenerPublicaciones"]),
        },
      });

      Vue.component("hijo", {
        template: `
          <div class="hijo">
            <h5>Componente Hijo</h5>
            <p>Contador: {{count}}</p>
            <button v-on:click="aumentar(razonMas)">+</button>            
            <button v-on:click="disminuir(razonMenos)">-</button>
            <br><br>
            <div>
              <button v-on:click="obtenerCursos">Obtener Cursos</button>
              <ul class="lista" v-for="(curso,index) in cursos">
                <li>{{curso.nombre}}</li>
              </ul>  
            </div>
                    
          </div>
        `,
        computed: {
          ...Vuex.mapState(["count", "razonMas", "razonMenos", "cursos"]),
        },
        methods: {
          ...Vuex.mapMutations(["aumentar", "disminuir"]),
          ...Vuex.mapActions(["obtenerCursos"]),
        },
      });

      const store = new Vuex.Store({
        state: {
          count: 0,
          razonMas: 5,
          razonMenos: 2,
          cursos: [],
          publicaciones: [],
        },
        mutations: {
          aumentar(state, n) {
            state.count += n;
          },
          disminuir(state, n) {
            state.count -= n;
          },
          llenarCursos(state, cursosAccion) {
            state.cursos = cursosAccion;
          },
          llenarPublicaciones(state, publicacionesAccion) {
            state.publicaciones = publicacionesAccion;
          },
        },
        actions: {
          obtenerCursos: async function ({ commit }) {
            const data = await fetch("./cursos.json");
            const cursos = await data.json();
            commit("llenarCursos", cursos);
          },
          obtenerPublicaciones: async function ({ commit }) {
            const data = await fetch(
              "https://jsonplaceholder.typicode.com/users"
            );
            const publicaciones = await data.json();
            commit("llenarPublicaciones", publicaciones);
          },
        },
      });

      new Vue({
        el: "#app",
        store,
        data: {
          titulo: "Vuex 3",
          razon: 5,
        },
      });
    </script>
    <style>
      .padre {
        border: 2px dotted;
        padding: 10px;
        text-align: center;
      }
      .hijo {
        border: 1px dotted;
        padding: 10px;
      }
      .lista {
        text-align: left;
      }
    </style>
  </body>
</html>
